#ifndef UTIL_H_
#define UTIL_H_

#ifdef __OpenBSD__
#include <unistd.h>
#else
#define pledge(p1, p2) 0
#define unveil(p1, p2) 0
#endif

#define DELIM '\t'
#define DELIMSTR "\t"

#undef strlcpy
size_t strlcpy(char *dst, const char *src, size_t dsize);

#undef strnlen
size_t strnlen(const char *str, size_t maxlen);

#undef strtonum
long long strtonum(const char *numstr, long long minval, long long maxval,
    const char **errstrp);

void * xreallocarray(void *m, size_t n, size_t s);

size_t allocarr(double **arr, const char *str, size_t maxlen);
int scannextval(char **str, double *val);
void printarr(double *arr, size_t len);
void printfarr(char *delimstr, int prec, double *arr, size_t len);
size_t fscanmatrix(FILE *stream, double ***arr, size_t *nf);

#endif
